// pr1arr.h -*-c++-*-
#ifndef _pr1arr_HDR_
#define _pr1arr_HDR_

#include<vector>
#include<iterator>
#include<algorithm>

#include<cassert>

namespace pu {
  template<typename S, unsigned int N> class n_arr { // for simple types "S"
  private:
    S data[N];
  public:
    n_arr() {}
    explicit n_arr(S const &s) { fill(s); }
    explicit n_arr(S const arr[N]){ std::copy(&arr[0],&arr[N],data); }
    template<typename IT> n_arr(IT const & bg,IT const & en){
      assert(N == std::distance(bg,en));
      std::copy(bg,en,data);
    }
    void fill(S const &s){ for(size_t i(0);i<N;++i){ data[i]=s; }
    }
    size_t const size() const { return N; }
    S& operator[](unsigned int const i) { return data[i]; }
    S const & operator[](unsigned int const i) const { return data[i]; }
    typedef S* iterator;
    typedef S const * const_iterator;
    iterator begin() { return data; }
    iterator end() {return &data[N];}
    const_iterator begin() const { return data; }
    const_iterator end() const {return &data[N];}
  };
} //of pu
#endif
